Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| J2ME Foundation
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.util
Class GregorianCalendar

    java.lang.Object
      |
      +--java.util.Calendar
            |
            +--java.util.GregorianCalendar

All Implemented Interfaces:
  Cloneable, Serializable

public class GregorianCalendar
extends Calendar

`GregorianCalendar` is a concrete subclass of `Calendar` and provides the standard calendar used by most of the world.

The standard (Gregorian) calendar has 2 eras, BC and AD.

This implementation handles a single discontinuity, which corresponds by default to the date the Gregorian calendar was instituted (October 15, 1582 in some countries, later in others). The cutover date may be changed by the caller by calling `setGregorianChange()`.

Historically, in those countries which adopted the Gregorian calendar first, October 4, 1582 was thus followed by October 15, 1582. This calendar models this correctly. Before the Gregorian cutover, `GregorianCalendar` implements the Julian calendar. The only difference between the Gregorian and the Julian calendar is the leap year rule. The Julian calendar specifies leap years every four years, whereas the Gregorian calendar omits century years which are not divisible by 400.

`GregorianCalendar` implements proleptic Gregorian and Julian calendars. That is, dates are computed by extrapolating the current rules indefinitely far backward and forward in time. As a result, `GregorianCalendar` may be used for all years to generate meaningful and consistent results. However, dates obtained using `GregorianCalendar` are historically accurate only from March 1, 4 AD onward, when modern Julian calendar rules were adopted. Before this date, leap year rules were applied irregularly, and before 45 BC the Julian calendar did not even exist.

Prior to the institution of the Gregorian calendar, New Year's Day was March 25. To avoid confusion, this calendar always uses January 1. A manual adjustment may be made if desired for dates that are prior to the Gregorian changeover and which fall between January 1 and March 24.

Values calculated for the `WEEK_OF_YEAR` field range from 1 to 53. Week 1 for a year is the earliest seven day period starting on `getFirstDayOfWeek()` that contains at least `getMinimalDaysInFirstWeek()` days from that year. It thus depends on the values of `getMinimalDaysInFirstWeek()`, `getFirstDayOfWeek()`, and the day of the week of January 1. Weeks between week 1 of one year and week 1 of the following year are numbered sequentially from 2 to 52 or 53 (as needed).

For example, January 1, 1998 was a Thursday. If `getFirstDayOfWeek()` is `MONDAY` and `getMinimalDaysInFirstWeek()` is 4 (these are the values reflecting ISO 8601 and many national standards), then week 1 of 1998 starts on December 29, 1997, and ends on January 4, 1998. If, however, `getFirstDayOfWeek()` is `SUNDAY`, then week 1 of 1998 starts on January 4, 1998, and ends on January 10, 1998; the first three days of 1998 then are part of week 53 of 1997.

Values calculated for the `WEEK_OF_MONTH` field range from 0 or 1 to 4 or 5. Week 1 of a month (the days with `WEEK_OF_MONTH = 1`) is the earliest set of at least `getMinimalDaysInFirstWeek()` contiguous days in that month, ending on the day before `getFirstDayOfWeek()`. Unlike week 1 of a year, week 1 of a month may be shorter than 7 days, need not start on `getFirstDayOfWeek()`, and will not include days of the previous month. Days of a month before week 1 have a `WEEK_OF_MONTH` of 0.

For example, if `getFirstDayOfWeek()` is `SUNDAY` and `getMinimalDaysInFirstWeek()` is 4, then the first week of January 1998 is Sunday, January 4 through Saturday, January 10. These days have a `WEEK_OF_MONTH` of 1. Thursday, January 1 through Saturday, January 3 have a `WEEK_OF_MONTH` of 0. If `getMinimalDaysInFirstWeek()` is changed to 3, then January 1 through January 3 have a `WEEK_OF_MONTH` of 1.

Example:

>      // get the supported ids for GMT-08:00 (Pacific Standard Time)
>      String[] ids = TimeZone.getAvailableIDs(-8 * 60 * 60 * 1000);
>      // if no ids were returned, something is wrong. get out.
>      if (ids.length == 0)
>          System.exit(0);

>       // begin output
>      System.out.println("Current Time");

>      // create a Pacific Standard Time time zone
>      SimpleTimeZone pdt = new SimpleTimeZone(-8 * 60 * 60 * 1000, ids[0]);

>      // set up rules for daylight savings time
>      pdt.setStartRule(Calendar.APRIL, 1, Calendar.SUNDAY, 2 * 60 * 60 * 1000);
>      pdt.setEndRule(Calendar.OCTOBER, -1, Calendar.SUNDAY, 2 * 60 * 60 * 1000);

>      // create a GregorianCalendar with the Pacific Daylight time zone
>      // and the current date and time
>      Calendar calendar = new GregorianCalendar(pdt);
>      Date trialTime = new Date();
>      calendar.setTime(trialTime);

>      // print out a bunch of interesting things
>      System.out.println("ERA: " + calendar.get(Calendar.ERA));
>      System.out.println("YEAR: " + calendar.get(Calendar.YEAR));
>      System.out.println("MONTH: " + calendar.get(Calendar.MONTH));
>      System.out.println("WEEK_OF_YEAR: " + calendar.get(Calendar.WEEK_OF_YEAR));
>      System.out.println("WEEK_OF_MONTH: " + calendar.get(Calendar.WEEK_OF_MONTH));
>      System.out.println("DATE: " + calendar.get(Calendar.DATE));
>      System.out.println("DAY_OF_MONTH: " + calendar.get(Calendar.DAY_OF_MONTH));
>      System.out.println("DAY_OF_YEAR: " + calendar.get(Calendar.DAY_OF_YEAR));
>      System.out.println("DAY_OF_WEEK: " + calendar.get(Calendar.DAY_OF_WEEK));
>      System.out.println("DAY_OF_WEEK_IN_MONTH: "
>                         + calendar.get(Calendar.DAY_OF_WEEK_IN_MONTH));
>      System.out.println("AM_PM: " + calendar.get(Calendar.AM_PM));
>      System.out.println("HOUR: " + calendar.get(Calendar.HOUR));
>      System.out.println("HOUR_OF_DAY: " + calendar.get(Calendar.HOUR_OF_DAY));
>      System.out.println("MINUTE: " + calendar.get(Calendar.MINUTE));
>      System.out.println("SECOND: " + calendar.get(Calendar.SECOND));
>      System.out.println("MILLISECOND: " + calendar.get(Calendar.MILLISECOND));
>      System.out.println("ZONE_OFFSET: "
>                         + (calendar.get(Calendar.ZONE_OFFSET)/(60*60*1000)));
>      System.out.println("DST_OFFSET: "
>                         + (calendar.get(Calendar.DST_OFFSET)/(60*60*1000)));

>      System.out.println("Current Time, with hour reset to 3");
>      calendar.clear(Calendar.HOUR_OF_DAY); // so doesn't override
>      calendar.set(Calendar.HOUR, 3);
>      System.out.println("ERA: " + calendar.get(Calendar.ERA));
>      System.out.println("YEAR: " + calendar.get(Calendar.YEAR));
>      System.out.println("MONTH: " + calendar.get(Calendar.MONTH));
>      System.out.println("WEEK_OF_YEAR: " + calendar.get(Calendar.WEEK_OF_YEAR));
>      System.out.println("WEEK_OF_MONTH: " + calendar.get(Calendar.WEEK_OF_MONTH));
>      System.out.println("DATE: " + calendar.get(Calendar.DATE));
>      System.out.println("DAY_OF_MONTH: " + calendar.get(Calendar.DAY_OF_MONTH));
>      System.out.println("DAY_OF_YEAR: " + calendar.get(Calendar.DAY_OF_YEAR));
>      System.out.println("DAY_OF_WEEK: " + calendar.get(Calendar.DAY_OF_WEEK));
>      System.out.println("DAY_OF_WEEK_IN_MONTH: "
>                         + calendar.get(Calendar.DAY_OF_WEEK_IN_MONTH));
>      System.out.println("AM_PM: " + calendar.get(Calendar.AM_PM));
>      System.out.println("HOUR: " + calendar.get(Calendar.HOUR));
>      System.out.println("HOUR_OF_DAY: " + calendar.get(Calendar.HOUR_OF_DAY));
>      System.out.println("MINUTE: " + calendar.get(Calendar.MINUTE));
>      System.out.println("SECOND: " + calendar.get(Calendar.SECOND));
>      System.out.println("MILLISECOND: " + calendar.get(Calendar.MILLISECOND));
>      System.out.println("ZONE_OFFSET: "
>             + (calendar.get(Calendar.ZONE_OFFSET)/(60*60*1000))); // in hours
>      System.out.println("DST_OFFSET: "
>             + (calendar.get(Calendar.DST_OFFSET)/(60*60*1000))); // in hours

Since:
  JDK1.1
See Also:
  `Calendar`, `TimeZone`, Serialized Form

Field Summary
`static int` | `AD` Value of the `ERA` field indicating the common era (Anno Domini), also known as CE.
`static int` | `BC` Value of the `ERA` field indicating the period before the common era (before Christ), also known as BCE.

Fields inherited from class java.util.Calendar
`AM, AM_PM, APRIL, areFieldsSet, AUGUST, DATE, DAY_OF_MONTH, DAY_OF_WEEK, DAY_OF_WEEK_IN_MONTH, DAY_OF_YEAR, DECEMBER, DST_OFFSET, ERA, FEBRUARY, FIELD_COUNT, fields, FRIDAY, HOUR, HOUR_OF_DAY, isSet, isTimeSet, JANUARY, JULY, JUNE, MARCH, MAY, MILLISECOND, MINUTE, MONDAY, MONTH, NOVEMBER, OCTOBER, PM, SATURDAY, SECOND, SEPTEMBER, SUNDAY, THURSDAY, time, TUESDAY, UNDECIMBER, WEDNESDAY, WEEK_OF_MONTH, WEEK_OF_YEAR, YEAR, ZONE_OFFSET`

Constructor Summary
`GregorianCalendar()` Constructs a default GregorianCalendar using the current time in the default time zone with the default locale.
`GregorianCalendar(int year, int month, int date)` Constructs a GregorianCalendar with the given date set in the default time zone with the default locale.
`GregorianCalendar(int year, int month, int date, int hour, int minute)` Constructs a GregorianCalendar with the given date and time set for the default time zone with the default locale.
`GregorianCalendar(int year, int month, int date, int hour, int minute, int second)` Constructs a GregorianCalendar with the given date and time set for the default time zone with the default locale.
`GregorianCalendar(Locale aLocale)` Constructs a GregorianCalendar based on the current time in the default time zone with the given locale.
`GregorianCalendar(TimeZone zone)` Constructs a GregorianCalendar based on the current time in the given time zone with the default locale.
`GregorianCalendar(TimeZone zone, Locale aLocale)` Constructs a GregorianCalendar based on the current time in the given time zone with the given locale.

Method Summary
`void` | `add(int field, int amount)` Overrides Calendar Date Arithmetic function.
`protected void` | `computeFields()` Overrides Calendar Converts UTC as milliseconds to time field values.
`protected void` | `computeTime()` Overrides Calendar Converts time field values to UTC as milliseconds.
`boolean` | `equals(Object obj)` Compares this GregorianCalendar to an object reference.
`int` | `getActualMaximum(int field)` Return the maximum value that this field could have, given the current date.
`int` | `getActualMinimum(int field)` Return the minimum value that this field could have, given the current date.
`int` | `getGreatestMinimum(int field)` Returns highest minimum value for the given field if varies.
`Date` | `getGregorianChange()` Gets the Gregorian Calendar change date.
`int` | `getLeastMaximum(int field)` Returns lowest maximum value for the given field if varies.
`int` | `getMaximum(int field)` Returns maximum value for the given field.
`int` | `getMinimum(int field)` Returns minimum value for the given field.
`int` | `hashCode()` Override hashCode.
`boolean` | `isLeapYear(int year)` Determines if the given year is a leap year.
`void` | `roll(int field, boolean up)` Overrides Calendar Time Field Rolling function.
`void` | `roll(int field, int amount)` Roll a field by a signed amount.
`void` | `setGregorianChange(Date date)` Sets the GregorianCalendar change date.

Methods inherited from class java.util.Calendar
`after, before, clear, clear, clone, complete, get, getAvailableLocales, getFirstDayOfWeek, getInstance, getInstance, getInstance, getInstance, getMinimalDaysInFirstWeek, getTime, getTimeInMillis, getTimeZone, internalGet, isLenient, isSet, set, set, set, set, setFirstDayOfWeek, setLenient, setMinimalDaysInFirstWeek, setTime, setTimeInMillis, setTimeZone, toString`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### BC

    public static final int BC

  Value of the `ERA` field indicating the period before the common era (before Christ), also known as BCE. The sequence of years at the transition from `BC` to `AD` is ..., 2 BC, 1 BC, 1 AD, 2 AD,...
  See Also:
    `Calendar.ERA`

### AD

    public static final int AD

  Value of the `ERA` field indicating the common era (Anno Domini), also known as CE. The sequence of years at the transition from `BC` to `AD` is ..., 2 BC, 1 BC, 1 AD, 2 AD,...
  See Also:
    `Calendar.ERA`

Constructor Detail

### GregorianCalendar

    public GregorianCalendar()

  Constructs a default GregorianCalendar using the current time in the default time zone with the default locale.

### GregorianCalendar

    public GregorianCalendar(TimeZone zone)

  Constructs a GregorianCalendar based on the current time in the given time zone with the default locale.
  Parameters:
    `zone` - the given time zone.

### GregorianCalendar

    public GregorianCalendar(Locale aLocale)

  Constructs a GregorianCalendar based on the current time in the default time zone with the given locale.
  Parameters:
    `aLocale` - the given locale.

### GregorianCalendar

    public GregorianCalendar(TimeZone zone,
                             Locale aLocale)

  Constructs a GregorianCalendar based on the current time in the given time zone with the given locale.
  Parameters:
    `zone` - the given time zone.
    `aLocale` - the given locale.

### GregorianCalendar

    public GregorianCalendar(int year,
                             int month,
                             int date)

  Constructs a GregorianCalendar with the given date set in the default time zone with the default locale.
  Parameters:
    `year` - the value used to set the YEAR time field in the calendar.
    `month` - the value used to set the MONTH time field in the calendar. Month value is 0-based. e.g., 0 for January.
    `date` - the value used to set the DATE time field in the calendar.

### GregorianCalendar

    public GregorianCalendar(int year,
                             int month,
                             int date,
                             int hour,
                             int minute)

  Constructs a GregorianCalendar with the given date and time set for the default time zone with the default locale.
  Parameters:
    `year` - the value used to set the YEAR time field in the calendar.
    `month` - the value used to set the MONTH time field in the calendar. Month value is 0-based. e.g., 0 for January.
    `date` - the value used to set the DATE time field in the calendar.
    `hour` - the value used to set the HOUR_OF_DAY time field in the calendar.
    `minute` - the value used to set the MINUTE time field in the calendar.

### GregorianCalendar

    public GregorianCalendar(int year,
                             int month,
                             int date,
                             int hour,
                             int minute,
                             int second)

  Constructs a GregorianCalendar with the given date and time set for the default time zone with the default locale.
  Parameters:
    `year` - the value used to set the YEAR time field in the calendar.
    `month` - the value used to set the MONTH time field in the calendar. Month value is 0-based. e.g., 0 for January.
    `date` - the value used to set the DATE time field in the calendar.
    `hour` - the value used to set the HOUR_OF_DAY time field in the calendar.
    `minute` - the value used to set the MINUTE time field in the calendar.
    `second` - the value used to set the SECOND time field in the calendar.

Method Detail

### setGregorianChange

    public void setGregorianChange(Date date)

  Sets the GregorianCalendar change date. This is the point when the switch from Julian dates to Gregorian dates occurred. Default is October 15, 1582. Previous to this, dates will be in the Julian calendar.

  To obtain a pure Julian calendar, set the change date to `Date(Long.MAX_VALUE)`. To obtain a pure Gregorian calendar, set the change date to `Date(Long.MIN_VALUE)`.

  Parameters:
    `date` - the given Gregorian cutover date.

### getGregorianChange

    public final Date getGregorianChange()

  Gets the Gregorian Calendar change date. This is the point when the switch from Julian dates to Gregorian dates occurred. Default is October 15, 1582. Previous to this, dates will be in the Julian calendar.
  Returns:
    the Gregorian cutover date for this calendar.

### isLeapYear

    public boolean isLeapYear(int year)

  Determines if the given year is a leap year. Returns true if the given year is a leap year.
  Parameters:
    `year` - the given year.
  Returns:
    true if the given year is a leap year; false otherwise.

### equals

    public boolean equals(Object obj)

  Compares this GregorianCalendar to an object reference.
  Overrides:
    `equals` in class `Calendar`
  Parameters:
    `obj` - the object reference with which to compare
  Returns:
    true if this object is equal to `obj`; false otherwise

### hashCode

    public int hashCode()

  Override hashCode. Generates the hash code for the GregorianCalendar object
  Overrides:
    `hashCode` in class `Calendar`
  Following copied from class: `java.util.Calendar`
  Returns:
    a hash code value for this object.

### add

    public void add(int field,
                    int amount)

  Overrides Calendar Date Arithmetic function. Adds the specified (signed) amount of time to the given time field, based on the calendar's rules.
  Overrides:
    `add` in class `Calendar`
  Parameters:
    `field` - the time field.
    `amount` - the amount of date or time to be added to the field.
  Throws:
    `IllegalArgumentException` - if an unknown field is given.

### roll

    public void roll(int field,
                     boolean up)

  Overrides Calendar Time Field Rolling function. Rolls (up/down) a single unit of time on the given time field.
  Overrides:
    `roll` in class `Calendar`
  Parameters:
    `field` - the time field.
    `up` - Indicates if rolling up or rolling down the field value.
  Throws:
    `IllegalArgumentException` - if an unknown field value is given.

### roll

    public void roll(int field,
                     int amount)

  Roll a field by a signed amount.
  Overrides:
    `roll` in class `Calendar`
  Since:
    1.2

### getMinimum

    public int getMinimum(int field)

  Returns minimum value for the given field. e.g. for Gregorian DAY_OF_MONTH, 1 Please see Calendar.getMinimum for descriptions on parameters and the return value.
  Overrides:
    `getMinimum` in class `Calendar`
  Following copied from class: `java.util.Calendar`
  Parameters:
    `field` - the given time field.
  Returns:
    the minimum value for the given time field.

### getMaximum

    public int getMaximum(int field)

  Returns maximum value for the given field. e.g. for Gregorian DAY_OF_MONTH, 31 Please see Calendar.getMaximum for descriptions on parameters and the return value.
  Overrides:
    `getMaximum` in class `Calendar`
  Following copied from class: `java.util.Calendar`
  Parameters:
    `field` - the given time field.
  Returns:
    the maximum value for the given time field.

### getGreatestMinimum

    public int getGreatestMinimum(int field)

  Returns highest minimum value for the given field if varies. Otherwise same as getMinimum(). For Gregorian, no difference. Please see Calendar.getGreatestMinimum for descriptions on parameters and the return value.
  Overrides:
    `getGreatestMinimum` in class `Calendar`
  Following copied from class: `java.util.Calendar`
  Parameters:
    `field` - the given time field.
  Returns:
    the highest minimum value for the given time field.

### getLeastMaximum

    public int getLeastMaximum(int field)

  Returns lowest maximum value for the given field if varies. Otherwise same as getMaximum(). For Gregorian DAY_OF_MONTH, 28 Please see Calendar.getLeastMaximum for descriptions on parameters and the return value.
  Overrides:
    `getLeastMaximum` in class `Calendar`
  Following copied from class: `java.util.Calendar`
  Parameters:
    `field` - the given time field.
  Returns:
    the lowest maximum value for the given time field.

### getActualMinimum

    public int getActualMinimum(int field)

  Return the minimum value that this field could have, given the current date. For the Gregorian calendar, this is the same as getMinimum() and getGreatestMinimum().
  Overrides:
    `getActualMinimum` in class `Calendar`
  Since:
    1.2

### getActualMaximum

    public int getActualMaximum(int field)

  Return the maximum value that this field could have, given the current date. For example, with the date "Feb 3, 1997" and the DAY_OF_MONTH field, the actual maximum would be 28; for "Feb 3, 1996" it s 29. Similarly for a Hebrew calendar, for some years the actual maximum for MONTH is 12, and for others 13.
  Overrides:
    `getActualMaximum` in class `Calendar`
  Since:
    1.2

### computeFields

    protected void computeFields()

  Overrides Calendar Converts UTC as milliseconds to time field values. The time is not recomputed first; to recompute the time, then the fields, call the `complete` method.
  Overrides:
    `computeFields` in class `Calendar`
  See Also:
    `Calendar.complete()`

### computeTime

    protected void computeTime()

  Overrides Calendar Converts time field values to UTC as milliseconds.
  Overrides:
    `computeTime` in class `Calendar`
  Throws:
    `IllegalArgumentException` - if any fields are invalid.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| J2ME Foundation
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Java is a trademark or registred trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2000 Sun Microsystems, Inc. 901 San Antonio Road,
Palo, Alto, California, 94303, U.S.A All Rights Reserved. < /font >